//========================================================================================
//
//	File:				FWFctInf.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFCTINF_H
#define FWFCTINF_H

#ifndef SLGDEV_H
#include "SLGDev.h"
#endif

//========================================================================================
//	Forward class declaration
//========================================================================================

class ODFacet;

//========================================================================================
//	class FW_SPrivFacetPartInfo
//========================================================================================
//	FW_SPrivFacetPartInfo is set in each one of our facet part info 

struct FW_SPrivFacetPartInfo
{
	unsigned long				fMagicNumber1;			// I just want to be sure that it is one of my facet
	unsigned long				fMagicNumber2;
	FW_HGDevice					fDevice;
	unsigned long				fRefCon;				// for users
};

//========================================================================================
//	Global Functions
//========================================================================================

// ----- Public API
FW_HGDevice 			FW_GetFacetGraphicDevice(Environment* ev, ODFacet* facet);
unsigned long 			FW_GetFacetRefCon(Environment* ev, ODFacet* facet);
void 					FW_SetFacetRefCon(Environment* ev, ODFacet* facet, unsigned long refCon);

// ----- Implementation only
FW_SPrivFacetPartInfo* 	FW_PrivCreateFacetPartInfo(Environment* ev, ODFacet* facet);
void 					FW_PrivDeleteFacetPartInfo(Environment* ev, ODFacet* facet);
FW_SPrivFacetPartInfo* 	FW_PrivGetFacetPartInfo(Environment* ev, ODFacet* facet);

#endif
