//========================================================================================
//
//	File:				FWWinRes.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWWINRES_H
#define FWWINRES_H

#ifdef FW_BUILD_WIN

#include <windows.h>

#endif

#ifdef FW_BUILD_MAC

#pragma options align=mac68k

// Windows resource structures taken from WINDOWS.H

#define FW_kWinBitmapSignature	0x4D42	

struct BITMAPFILEHEADER
{
	unsigned short	bfType;
	unsigned long	bfSize;
	unsigned short	bfReserved1;
	unsigned short	bfReserved2;
	unsigned long	bfOffBits;
};

struct BITMAPINFOHEADER
{
	unsigned long	biSize;
	unsigned long	biWidth;
	unsigned long	biHeight;
	unsigned short	biPlanes;
	unsigned short	biBitCount;

	unsigned long	biCompression;
	unsigned long	biSizeImage;
	unsigned long	biXPelsPerMeter;
	unsigned long	biYPelsPerMeter;
	unsigned long	biClrUsed;
	unsigned long	biClrImportant;
};

struct BITMAPCOREHEADER
{
	unsigned long	bcSize;       // used to get to color table
	unsigned short	bcWidth;
	unsigned short	bcHeight;
	unsigned short	bcPlanes;
	unsigned short	bcBitCount;
};

struct RGBTRIPLE
{
	unsigned char	rgbtBlue;
	unsigned char	rgbtGreen;
	unsigned char	rgbtRed;
};

struct BITMAPCOREINFO
{
	BITMAPCOREHEADER	bmciHeader;
	RGBTRIPLE			bmciColors[1];
};

struct RGBQUAD
{
	unsigned char	rgbBlue;
	unsigned char	rgbGreen;
	unsigned char	rgbRed;
	unsigned char	rgbReserved;
};

struct BITMAPINFO
{
    BITMAPINFOHEADER	bmiHeader;
    RGBQUAD				bmiColors[1];
};

#pragma options align=reset

#endif

#endif // FWWINRES_H
