//========================================================================================
//
//	File:				SLPalete.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLPALETE_H
#define SLPALETE_H

#ifndef SLCOLOR_H
#include "SLColor.h"
#endif

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

//========================================================================================
//	Palette type
//========================================================================================

#ifdef FW_BUILD_WIN
typedef HPALETTE	FW_Palette;
#endif

#ifdef FW_BUILD_MAC
typedef CTabHandle	FW_Palette;
#endif

//========================================================================================
//	Palette functions
//========================================================================================

FW_Palette SL_API 	FW_PrivCreatePalette(const FW_SColor* colors,
							short nColorCount);

short SL_API		FW_GetPaletteSize(FW_Palette palette);

void SL_API			FW_SetPaletteEntries(FW_Palette palette,
							const FW_SColor* colors,
							short nStartIndex,
							short nColorCount);

void SL_API			FW_GetPaletteEntries(FW_Palette palette,
							FW_SColor* colors,
							short nStartIndex,
							short nColorCount);

FW_Palette SL_API	FW_PrivCopyPalette(FW_Palette palette);

void SL_API			FW_DestroyPalette(FW_Palette palette);

FW_EXTERN_C_END
								
// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif // SLPALETE_H
