//========================================================================================
//
//	File:				SLPictur.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLPICTUR_H
#define SLPICTUR_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef SLGRDEF_H
#include "SLGrDef.h"
#endif

#ifndef SLPTRECT_H
#include "SLPtRect.h"
#endif

#ifndef SLSTRMRW_H
#include "SLStrmRW.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_OResourceFile;
struct FW_SGraphicContext;

//========================================================================================
// Picture
//========================================================================================

class FW_CPrivPictureRep;
typedef FW_CPrivPictureRep* FW_HPicture;

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

// Creation

FW_HPicture			SL_API	FW_PrivPicture_CreateFromResource(
								FW_OResourceFile* 	resourceFile,
								FW_ResourceId 		resId,
								FW_PlatformError* 	error);

FW_HPicture			SL_API	FW_PrivPicture_CreateFromPlatformPict(
								FW_PlatformPict 	platformPict,
								FW_PlatformError* 	error);

FW_HPicture			SL_API	FW_PrivPicture_Copy(FW_HPicture picture, FW_PlatformError* 	error);

// Reference counting

void				SL_API	FW_PrivPicture_Acquire(FW_HPicture picture);
long				SL_API	FW_PrivPicture_GetRefCount(FW_HPicture picture);
void				SL_API	FW_PrivPicture_Release(FW_HPicture picture);

FW_Boolean			SL_API	FW_PrivPicture_IsEqual(FW_HPicture picture, FW_HPicture picture2);

// Bounds

void				SL_API	FW_PrivPicture_GetPictBounds(
								FW_HPicture 		picture,
								FW_SRect& 			bounds);

void				SL_API	FW_PrivPicture_GetPictBoundsGC(Environment* ev,
								FW_HPicture 		picture,
								FW_SGraphicContext&	gc,
								FW_SRect&			bounds);

FW_PlatformPict		SL_API	FW_PrivPicture_GetPlatformPict(FW_HPicture picture);
FW_Boolean			SL_API	FW_PrivPicture_IsPlatformPictOrphan(FW_HPicture picture);
FW_PlatformPict		SL_API	FW_PrivPicture_OrphanPlatformPict(FW_HPicture picture);
	
FW_PlatformError	SL_API	FW_PrivPicture_SetPlatformPict(FW_HPicture picture, FW_PlatformPict newPict);
FW_PlatformError	SL_API	FW_PrivPicture_AdoptPlatformPict(FW_HPicture picture, FW_PlatformPict newPict);

#ifdef FW_BUILD_MAC
FW_PlatformError	SL_API	FW_PrivPicture_MacLock(FW_HPicture picture);
FW_PlatformError	SL_API	FW_PrivPicture_MacUnlock(FW_HPicture picture);
#endif

// Streaming

FW_HPicture			SL_API	FW_PrivPicture_Read(FW_HReadableStream stream, FW_PlatformError* error);

void				SL_API	FW_PrivPicture_Write(
								FW_HPicture 		picture,
								FW_HWritableStream	stream,
								FW_PlatformError* 	error);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif // SLPICTUR_H
